#--
# ===========================================================================
# Copyright (c) 2005-2017 Christopher Kleckner
# All rights reserved
#
# This file is part of the Rio library for ruby.
#
# Rio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Rio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rio; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# =========================================================================== 
#++
#


require 'rio/context/cxx.rb'
module RIO
  module Cx
    module Methods
      def copying_to() cx['copying_to'] = true; self end
      def copying_to?() cx['copying_to'] end
      def copying_to_done() cx.delete('copying_to'); self end

      def copying_from() cx['copying_from'] = true; self end
      def copying_from?() cx['copying_from'] end
      def copying_from_done() cx.delete('copying_from'); self end

      def copying(dest) dest.copying_to; copying_from end
      def copying?() copying_to? or copying_from? end
      def copying_done(dest) dest.copying_to_done; copying_from_done end
    end
  end
end
      
